// This file is to be included only - it does not do anything if
// executed directly

operator PropagateChanges(s1, d1, s1_d1,
                          s2, c,  s2_c) {

  // TASK 1: propagate deletions
  (s1_s2, multimap) = Match(s1, s2, NGramMatch(s1, s2));
  s1_s2 = EditMap(s1, s2, s1_s2, multimap, "s1_s2: original-modified");
  (d1', d1'_d1) = Delete(d1, Traverse(All(s1) - Domain(s1_s2), s1_d1));
  
  // TASK 2: propagate additions/renamings
  c_add = Traverse(All(s2) - Range(Forward(s1_s2)), s2_c);
  (c', c'_c) = Extract(c, c_add);
//  c_d1 = Invert(s2_c) * Invert(s1_s2) * s1_d1;

  c'_d1' = c'_c * Invert(s2_c) * Invert(s1_s2) * s1_d1 * Invert(d1'_d1);

  // next two lines are optional
  c'_d1' = Match(c', d1', c'_d1'); // OneSimilarity(c_d1));
  c'_d1' = RestrictDomain(c'_d1', All(c') -
                                  Traverse(All(s2) - Range(s1_s2), s2_c * Invert(c'_c)));
  c'_d1' = EditMap(c', d1', c'_d1', null, "c'_d1' to be used for Merge");

  (d2, c'_d2, d1'_d2) = Merge(c', d1', c'_d1'); // new version
  
  // TASK 3: compute new mapping s1_d1
  s2_d2 = s2_c * Invert(c'_c) * c'_d2 + Invert(s1_s2) * s1_d1 * Invert(d1'_d1) * d1'_d2;

  s2_d2 = EditMap(s2, d2, s2_d2, null, "new s1_d1");

  return (d2, s2_d2);
}




// Same as above but showing more popup windows
operator PropagateChangesVerbose(s1, d1, s1_d1,
                                 s2, c,  s2_c) {

  // TASK 1: propagate deletions
  
  (s1_s2, multimap) = Match(s1, s2, NGramMatch(s1, s2));
  s1_s2 = EditMap(s1, s2, s1_s2, multimap, "s1_s2: original and modified schemas");
//  s1_s2 = EditMap(s1, s2, ReverseNonIdentical(s1, s2, s1_s2), multimap, "s1_s2: original and modified schemas");
  
  d1_del = Traverse(All(s1) - Domain(s1_s2), s1_d1); // unmatched elements in d1
  	d1_del = EditSelector(d1, d1_del, "Elements to be soft-deleted from d1");
  
  (d1', d1'_d1) = Delete(d1, d1_del);  // soft since PK should stay
  	popup(d1', Obj2Text, "d1 without deleted elements");
  
  
  // TASK 2: propagate additions/renamings
  
  s2_add = All(s2) - Range(Forward(s1_s2)); // need to add backward as well; consider them unmatched here
  	s2_add = EditSelector(s2, s2_add, "New/renamed elements in s2");
        // why not select s2_add first and convert: operator less generic (conversion built-in)
  
  s2_c = EditMap(s2, c, s2_c, null, "s2_c: converted s2 to c");
  
  c_add = Traverse(s2_add, s2_c);
  	c_add = EditSelector(c, c_add, "New/renamed elements to add from c");
  
  (c', c'_c) = Extract(c, c_add);
//  c' = Extract(c, c_add, Dependencies(c)); // needed for xsd-rdb (PK/FK)
  	popup(c', Obj2Text, "c': portion of c to be added");
  
  c'_d1' = c'_c * Invert(s2_c) * Invert(s1_s2) * s1_d1 * Invert(d1'_d1);
  	c'_d1' = EditMap(c', d1', c'_d1', null, "First cut c'_d1' (by composition, w/o Match)");

  // next two lines are optional: match surrounding elements
  c'_d1' = Match(c', d1', c'_d1'); // OneSimilarity(c_d1));
  // make sure that new elements remain unmatched; second term is similar to c_add...
  c'_d1' = RestrictDomain(c'_d1', All(c') -
                                            Traverse(All(s2) - Range(s1_s2), s2_c * Invert(c'_c)));
  	// EditMap(c', d1', c'_d1', multimap, "c'_d1' after Match");
  
  do {
  	c'_d1' = EditMap(c', d1', c'_d1', null, "c'_d1' to be used for Merge");
  
       (d2, c'_d2, d1'_d2) = Merge(c', d1', c'_d1'); // new version
  
  // TASK 3: compute new mapping s1_d1
  
    s2_d2 = s2_c * Invert(c'_c) * c'_d2 + Invert(s1_s2) * s1_d1 * Invert(d1'_d1) * d1'_d2;
    s2_d2 = EditMap(s2, d2, s2_d2, null, "new s1_d1 to be stored");

  } while(YesNo("Repeat merge?"));
  

  return (d2, s2_d2);
}
